## php8.1 8.1.34

=== debian/changelog ===
php8.1 (8.1.34-1+0~20251218.73+debian11~1.gbp9e917b) unstable; urgency=medium

  ** SNAPSHOT build @9e917b16e868ac818af591113a2caf741054a289 **

  * UNRELEASED

 -- Ondřej Surý <ondrej@sury.org>  Fri, 19 Dec 2025 00:12:18 +0100

php8.1 (8.1.34-1) unstable; urgency=medium

  * Add preliminary LiteSpeed SAPI support
  * Update d/watch for new download page
  * New upstream version 8.1.34
   + [CVE-2025-14180]: Fixed GHSA-8xr5-qppj-gvwj (PDO quoting result null
     deref).
   + [CVE-2025-14178]: Fixed GHSA-h96m-rvf9-jgm2 (Heap buffer overflow in
     array_merge()).
   + [CVE-2025-14177]: Fixed GHSA-3237-qqm7-mfv7 (Information Leak of
     Memory in getimagesize).

 -- Ondřej Surý <ondrej@debian.org>  Thu, 18 Dec 2025 21:07:43 +0100

php8.1 (8.1.33-4) unstable; urgency=medium

  * Or just use /bin/sed; that should work everywhere

 -- Ondřej Surý <ondrej@debian.org>  Thu, 20 Nov 2025 10:24:56 +0100

php8.1 (8.1.33-3) unstable; urgency=medium

  * Workaround make $(shell ...) command unable to execute builtins

 -- Ondřej Surý <ondrej@debian.org>  Thu, 20 Nov 2025 08:55:31 +0100

php8.1 (8.1.33-2) unstable; urgency=medium

  * Use command -v sed to resolve path to SED

 -- Ondřej Surý <ondrej@debian.org>  Fri, 14 Nov 2025 17:26:21 +0100
